from humerus.main_commands import MainCommandScreen
from pygame.locals import *
from albow.resource import get_image

class Mutate_MainMenu(MainCommandScreen):
	menu_items = [
		("New Game",         'new_game',           [K_n]),
		("Quit",             'quit',               [K_q]),
	]
	
	def __init__(self, shell, with_menu = False):
		MainCommandScreen.__init__(self, shell, with_menu )
		self.init_command_map()
		if with_menu:
			self.background = get_image("title.png")
			self.background = self.background.convert()

	def add_title_and_menu(self, title, menu):
		from albow.layout import Column
		items = [menu]
		if title:
			items.insert(0, title)
		box = Column(items, align = 'l', spacing = 20)
		c = self.center
		box.center = (self.centerx, 400)
		self.add(box)

	def draw(self, surface):
		MainCommandScreen.draw(self, surface)
		surface.blit( self.background, (0,0) )